unit saa1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    CheckBox4: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    RG_phasedetector: TRadioGroup;
    RG_testpin: TRadioGroup;
    RG_currentamp: TRadioGroup;
    procedure bytesend(c : char);
    procedure compute_latch_a;
    procedure compute_latch_b;
    procedure set_dlen(b : byte);
    procedure bitsend(bit : byte);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}
procedure  PortOut(Port : Word; Data : Byte); stdcall; external 'io.dll';
function PortIn(Port:Word):Byte; stdcall; external 'io.dll';

const
  binary : array[0..14] of dword = (1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384);
  dlen = 4;
  clb = 1;
  data = 2;
  lpt = $378;
  waitingtime = 1;
var
  a,devider : word;
  latcha,latchb : array[0..14] of byte;

procedure tform1.set_dlen(b : byte);
begin
portout(lpt,dlen*b);
end;

procedure tform1.bitsend(bit : byte);
var
  b : byte;
begin
b:= bit*data;
portout(lpt,b or dlen); // datenbit anlegen
sleep(waitingtime);
portout(lpt,b or dlen or clb); // clock high
sleep(waitingtime*2);
portout(lpt,b or dlen); // clock low
sleep(waitingtime);
end;


procedure tform1.bytesend(c : char);
var
  n : integer;
begin
bitsend(0); // leading zero
case c of
  'a' : begin
          bitsend(0);
          for n:= 14 downto 0 do bitsend(latcha[n]);
        end;
  'b' : begin
          bitsend(1);
          for n:= 14 downto 0 do bitsend(latchb[n]);
        end;
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
compute_latch_B;
button1.Caption := 'working';
set_dlen(1);
sleep(waitingtime);
bytesend('b');
set_dlen(0);
sleep(waitingtime);
portout(lpt,clb); // clock high
sleep(waitingtime);
portout(lpt,0); // clock low
sleep(waitingtime*1);
////////////////////////////////////////////////////
set_dlen(1);
sleep(waitingtime);
bytesend('a');
set_dlen(0);
sleep(waitingtime);
portout(lpt,clb); // clock high
sleep(waitingtime);
portout(lpt,0); // clock low
sleep(waitingtime);
button1.Caption := 'transmit';
end;

procedure tform1.compute_latch_a;
begin
for a:= 14 downto 0 do begin
  if devider >= binary[a] then begin
    latcha[a]:= 1;
    devider:= devider - binary[a];
  end
  else latcha[a]:= 0;
end;
end;

procedure tform1.compute_latch_b;
var n : integer;
begin
for n:= 0 to 14 do latchb[n]:= 0;
if checkbox14.Checked then latchb[14]:= 1;
if checkbox13.Checked then latchb[13]:= 1;
if checkbox8.Checked then latchb[8]:= 1;
if checkbox7.Checked then latchb[7]:= 1;
if checkbox4.Checked then latchb[4]:= 1;

case RG_currentamp.ItemIndex of
  1 : latchb[9]:= 1;
  2 : latchb[10]:= 1;
  3 : begin
        latchb[11]:= 1;
        latchb[10]:= 1;
      end;
  4 : begin
        latchb[12]:= 1;
        latchb[11]:= 1;
        latchb[10]:= 1;
      end;
end;

case RG_phasedetector.ItemIndex of
  1 : latchb[6]:= 1;
  2 : begin
        latchb[6]:= 1;
        latchb[5]:= 1;
      end;
end;

case RG_testpin.ItemIndex of
  0 : latchb[2]:= 1;
  1 : latchb[0]:= 1;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
portout(lpt,0);
devider := 9170;
compute_latch_a;
RG_currentamp.ItemIndex := 2;
RG_phasedetector.ItemIndex := 1;

end;



procedure TForm1.Edit1Change(Sender: TObject);
begin
devider := strtoint(edit1.text);
compute_latch_a;
end;

end.
